#include "stdafx.h"
#include "rectangle.h"

ilRectangle ilRectangleRotateCenter(ilRectangle r, double a, double cx, double cy)
{
  double m11=cos(a), m12=sin(a), m21=-sin(a), m22=cos(a);
  double x=r.x-cx, y=r.y-cy, w=r.w, h=r.h;
  
  double x1=m11*x + m12*y,         y1=m21*x + m22*y;          // top-left 
  double x2=m11*(x+w) + m12*y,     y2=m21*(x+w) + m22*y;      // top-right 
  double x3=m11*(x+w) + m12*(y+h), y3=m21*(x+w) + m22*(y+h);  // bottom-right 
  double x4=m11*x + m12*(y+h),     y4=m21*x + m22*(y+h);      // bottom-left
  
  double xmin=min(min(min(x1,x2),x3),x4);
  double ymin=min(min(min(y1,y2),y3),y4);
  double xmax=max(max(max(x1,x2),x3),x4);
  double ymax=max(max(max(y1,y2),y3),y4);

  return ilRectangle(xmin+cx,ymin+cy,xmax-xmin,ymax-ymin);
}
